---------------------
PatchSet 3154 
Date: 2005/05/04 14:56:04
Author: cladisch
Branch: HEAD
Tag: (none) 
Log:
Summary: usb-audio - set sample rate attribute on Audigy 2 NX endpoints

The SB Audigy 2 NX does not advertise the sample rate attribute in its
endpoint descriptors although it supports it.

Members: 
	usb/usbaudio.c:1.127->1.128 

Index: /sound/usb/usbaudio.c
diff -u /sound/usb/usbaudio.c.old /sound/usb/usbaudio.c
--- /sound/usb/usbaudio.c.old	Mon May  2 00:55:54 2005
+++ /sound/usb/usbaudio.c	Wed May  4 06:56:04 2005
@@ -2499,32 +2499,31 @@
 
 		/* some quirks for attributes here */
 
-		/* workaround for AudioTrak Optoplay */
-		if (chip->usb_id == USB_ID(0x0a92, 0x0053)) {
+		switch (chip->usb_id) {
+		case USB_ID(0x0a92, 0x0053): /* AudioTrak Optoplay */
 			/* Optoplay sets the sample rate attribute although
 			 * it seems not supporting it in fact.
 			 */
 			fp->attributes &= ~EP_CS_ATTR_SAMPLE_RATE;
-		}
-
-		/* workaround for M-Audio Audiophile USB */
-		if (chip->usb_id == USB_ID(0x0763, 0x2003)) {
+			break;
+		case USB_ID(0x041e, 0x3020): /* Creative SB Audigy 2 NX */
+		case USB_ID(0x0763, 0x2003): /* M-Audio Audiophile USB */
 			/* doesn't set the sample rate attribute, but supports it */
 			fp->attributes |= EP_CS_ATTR_SAMPLE_RATE;
-		}
-
+			break;
+		case USB_ID(0x047f, 0x0ca1): /* plantronics headset */
+		case USB_ID(0x077d, 0x07af): /* Griffin iMic (note that there is
+						an older model 77d:223) */
 		/*
 		 * plantronics headset and Griffin iMic have set adaptive-in
 		 * although it's really not...
 		 */
-		if (chip->usb_id == USB_ID(0x047f, 0x0ca1) ||
-		    /* Griffin iMic (note that there is an older model 77d:223) */
-		    chip->usb_id == USB_ID(0x077d, 0x07af)) {
 			fp->ep_attr &= ~EP_ATTR_MASK;
 			if (stream == SNDRV_PCM_STREAM_PLAYBACK)
 				fp->ep_attr |= EP_ATTR_ADAPTIVE;
 			else
 				fp->ep_attr |= EP_ATTR_SYNC;
+			break;
 		}
 
 		/* ok, let's parse further... */
